local ST = LibStub("AceAddon-3.0"):GetAddon("SurgeTrack", true)
local STD = ST:NewModule("SurgeTrack_Data")

local _, classFileName = UnitClass("player")
local _, _, _, uiVersion = GetBuildInfo()
local ClassAuraData, CommonAuraData, ClassSpellData

local AuraClassTocFilterActive = true
local AuraCommonTocFilterActive = true
local SpellClassTocFilterActive = true
local SpellIdFilterActive = true

function ST:LoadSTD()
 ST:EnableModule("SurgeTrack_Data")
 ST:DisableModule("SurgeTrack_Data")
end
function STD:OnEnable()
 STD:ImportData()
 STD:InitData()
 STD:LoadAuraClassData(AuraClassTocFilterActive)
 STD:LoadAuraCommonData(AuraCommonTocFilterActive)
 STD:LoadSpellClassData(SpellClassTocFilterActive)
 --STD.data.aura.class[SpellId] = IsEnabled
 --STD.data.aura.common[SpellId] = IsEnabled
 --STD.data.spell.class[SpellId] = IsEnabled
 --STD.desc.aura.class[SpellId] = triggerSpellIcon .. triggerSpellName .. triggerSpellRank
 --STD.desc.spell.class[SpellId] = spellIcon .. spellName .. spellRank
end
function STD:ImportData()

ClassAuraData = {
 DEATHKNIGHT = {
  [81340] = {
   --aura = 81340,--Sudden Doom
   trigger = {
    [1] = 49018,--Sudden Doom Rank 1
    [2] = 49529,--Sudden Doom Rank 2
    [3] = 49530,--Sudden Doom Rank 3
   },
   enable = true,
   toc = nil,
  },
  [53365] = {
   --aura = 53365,--Unholy Strength
   trigger = {
    [1] = 53344,--Rune of the Fallen Crusader
   },
   enable = true,
   toc = nil,
  },
  [59052] = {
   --aura = 59052,--Freezing Fog
   trigger = {
    [1] = 49188,--Rime Rank 1
    [2] = 56822,--Rime Rank 2
    [3] = 59057,--Rime Rank 3
   },
   enable = true,
   toc = nil,
  },
  [51124] = {
   --aura = 51124,--Killing Machine
   trigger = {
    [1] = 51123,--Killing Machine Rank 1
    [2] = 51127,--Killing Machine Rank 2
    [3] = 51128,--Killing Machine Rank 3
    [4] = 51129,--Killing Machine Rank 4
    [5] = 51130,--Killing Machine Rank 5
   },
   enable = true,
   toc = nil,
  },
  [53386] = {
   --aura = 53386,--Cinderglacier
   trigger = {
    [1] = 53386,--trigger missing
   },--missing!
   enable = true,
   toc = nil,
  },
  [50466] = {
   --aura = 50466,--Death Trance!
   trigger = {
    [1] = 49018,--Sudden Doom Rank 1
    [2] = 49529,--Sudden Doom Rank 2
    [3] = 49530,--Sudden Doom Rank 3
    [4] = 49531,--Sudden Doom Rank 4
    [5] = 49532,--Sudden Doom Rank 5
   },
   enable = true,
   toc = nil,
  },
 },
 DRUID = {
  [93400] = {
   --aura = 93400,--Shooting Stars
   trigger = {
    [1] = 93398,--Shooting Stars Rank 1
    [2] = 93399,--Shooting Stars Rank 2
   },
   enable = true,
   toc = nil,
  },
  [48517] = {
   --aura = 48517,--Eclipse
   trigger = {
    [1] = 48516,--Eclipse Rank 1
    [2] = 48521,--Eclipse Rank 2
    [3] = 48525,--Eclipse Rank 3
   },
   enable = true,
   toc = nil,
  },
  [48518] = {
   --aura = 48518,--Eclipse
   trigger = {
    [1] = 48516,--Eclipse Rank 1
    [2] = 48521,--Eclipse Rank 2
    [3] = 48525,--Eclipse Rank 3
   },
   enable = true,
   toc = nil,
  },
  [16886] = {
   --aura = 16886,--Nature's Grace
   trigger = {
    [1] = 16880,--Nature's Grace Rank 1
    [2] = 61345,--Nature's Grace Rank 2
    [3] = 61346,--Nature's Grace Rank 3
   },
   enable = true,
   toc = nil,
  },
  [48391] = {
   --aura = 48391,--Owlkin Frenzy
   trigger = {
    [1] = 48389,--Owlkin Frenzy Rank 1
    [2] = 48392,--Owlkin Frenzy Rank 2
    [3] = 48393,--Owlkin Frenzy Rank 3
   },
   enable = true,
   toc = nil,
  },
  [46833] = {
   --aura = 46833,--Wrath of Elune
   trigger = {
    [1] = 46832,--Moonkin Starfire Bonus
   },
   enable = false,
   toc = nil,
  },
  [69369] = {
   --aura = 69369,--Predator's Swiftness
   trigger = {
    [1] = 16972,--Predatory Strikes Rank 1
    [2] = 16974,--Predatory Strikes Rank 2
    [3] = 16975,--Predatory Strikes Rank 3
   },
   enable = true,
   toc = nil,
  },
  [16870] = {
   --aura = 16870,--Clearcasting
   trigger = {
    [1] = 64752,--Item - Druid T8 Feral 2P Bonus
    [2] = 16864,--Omen of Clarity
   },
   enable = true,
   toc = nil,
  },
 },
 HUNTER = {
  [82925] = {
   --aura = 82925,--Ready, Set, Aim...
   trigger = {
    [1] = 34485,--Master Marksman Rank 1
    [2] = 34486,--Master Marksman Rank 2
    [3] = 34487,--Master Marksman Rank 3
   },
   enable = true,
   toc = nil,
  },
  [53220] = {
   --aura = 53220,--Improved Steady Shot
   trigger = {
    [1] = 53221,--Improved Steady Shot Rank 1
    [2] = 53222,--Improved Steady Shot Rank 2
    [3] = 53224,--Improved Steady Shot Rank 3
   },
   enable = true,
   toc = nil,
  },
  [56453] = {
   --aura = 56453,--Lock and Load
   trigger = {
    [1] = 56342,--Lock and Load Rank 1
    [2] = 56343,--Lock and Load Rank 2
    [3] = 56344,--Lock and Load Rank 3
   },
   enable = true,
   toc = nil,
  },
  [35098] = {
   --aura = 35098,--Rapid Killing Rank 1
   trigger = {
    [1] = 34948,--Rapid Killing Rank 1
   },
   enable = true,
   toc = nil,
  },
  [35099] = {
   --aura = 35099,--Rapid Killing Rank 2
   trigger = {
    [1] = 34949,--Rapid Killing Rank 2
   },
   enable = true,
   toc = nil,
  },
  [53254] = {
   --aura = 53254,--Wild Quiver Auto Shot
   trigger = {
    [1] = 53215,--Wild Quiver Rank 1
    [2] = 53216,--Wild Quiver Rank 2
    [3] = 53217,--Wild Quiver Rank 3
   },
   enable = true,
   toc = nil,
  },
  [34833] = {
   --aura = 34833,--Master Tactician
   trigger = {
    [1] = 34506,--Master Tactician Rank 1
   },
   enable = true,
   toc = nil,
  },
  [34834] = {
   --aura = 34834,--Master Tactician
   trigger = {
    [1] = 34507,--Master Tactician Rank 2
   },
   enable = true,
   toc = nil,
  },
  [34835] = {
   --aura = 34835,--Master Tactician
   trigger = {
    [1] = 34508,--Master Tactician Rank 3
   },
   enable = true,
   toc = nil,
  },
  [34836] = {
   --aura = 34836,--Master Tactician
   trigger = {
    [1] = 34838,--Master Tactician Rank 4
   },
   enable = true,
   toc = nil,
  },
  [34837] = {
   --aura = 34837,--Master Tactician
   trigger = {
    [1] = 34839,--Master Tactician Rank 5
   },
   enable = true,
   toc = nil,
  },
  [6150] = {
   --aura = 6150,--Quick Shots
   trigger = {
    [1] = 6150,--trigger missing
   },
   enable = true,
   toc = nil,
  },
  [34501] = {
   --aura = 34501,--Expose Weakness
   trigger = {
    [1] = 34500,--Expose Weakness Rank 1
    [2] = 34502,--Expose Weakness Rank 2
    [3] = 34503,--Expose Weakness Rank 3
   },
   enable = true,
   toc = nil,
  },
  -- [57669] = {
   -- aura = 57669,--Replenishment
   -- trigger = {
    -- [1] = 53290,--Hunting Party Rank 1
    -- [2] = 53291,--Hunting Party Rank 2
    -- [3] = 53292,--Hunting Party Rank 3
    -- [4] = 53293,--Hunting Party Rank 4
    -- [5] = 53294,--Hunting Party Rank 5
   -- },
   -- enable = true,
   -- toc = 30300,
  -- },
  [64861] = {
   --aura = 64861,--Precision Shots
   trigger = {
    [1] = 64860,--Item - Hunter T8 4P Bonus
   },
   enable = false,
   toc = nil,
  },
 },
 MAGE = {
  [79683] = {
   --aura = 79683,--Arcane Missiles!
   trigger = {
    [1] = 79683,--Arcane Missiles!
   },
   enable = true,
   toc = nil,
  },
  [31643] = {
   --aura = 31643,--Blazing Speed
   trigger = {
    [1] = 31643,--Blazing Speed
   },
   enable = true,
   toc = nil,
  },
  [36032] = {
   --aura = 36032,--Arcane Blast
   trigger = {
    [1] = 30451,--Arcane Blast Rank 1
    [2] = 42894,--Arcane Blast Rank 2
    [3] = 42896,--Arcane Blast Rank 3
    [4] = 42897,--Arcane Blast Rank 4
   },
   enable = true,
   toc = nil,
  },
  [57761] = {
   --aura = 57761,--Fireball!
   trigger = {
    [1] = 44546,--Brain Freeze Rank 1
    [2] = 44548,--Brain Freeze Rank 2
    [3] = 44549,--Brain Freeze Rank 3
   },
   enable = true,
   toc = nil,
  },
  [12536] = {
   --aura = 12536,--Clearcasting
   trigger = {
    [1] = 11213,--Arcane Concentration Rank 1
    [2] = 12574,--Arcane Concentration Rank 2
    [3] = 12575,--Arcane Concentration Rank 3
    [4] = 12576,--Arcane Concentration Rank 4
    [5] = 12577,--Arcane Concentration Rank 5
   },
   enable = true,
   toc = nil,
  },
  [48108] = {
   --aura = 48108,--Hot Streak
   trigger = {
    [1] = 48108,--Hot Streak
   },
   enable = true,
   toc = nil,
  },
  [44401] = {
   --aura = 44401,--Missile Barrage
   trigger = {
    [1] = 44404,--Missile Barrage Rank 1
    [2] = 54486,--Missile Barrage Rank 2
    [3] = 54488,--Missile Barrage Rank 3
    [4] = 54489,--Missile Barrage Rank 4
    [5] = 54490,--Missile Barrage Rank 5
   },
   enable = true,
   toc = nil,
  },
  [54741] = {
   --aura = 54741,--Firestarter
   trigger = {
    [1] = 44442,--Firestarter Rank 1
    [2] = 44443,--Firestarter Rank 2
   },
   enable = true,
   toc = nil,
  },
  [44544] = {
   --aura = 44544,--Fingers of Frost
   trigger = {
    [1] = 44543,--Fingers of Frost Rank 1
    [2] = 44545,--Fingers of Frost Rank 2
   },
   enable = true,
   toc = nil,
  },
  [64343] = {
   --aura = 64343,--Impact Rank 1
   trigger = {
    [1] = 11103,--Impact Rank 1
    [2] = 12357,--Impact Rank 2
    [3] = 12358,--Impact Rank 3
   },
   enable = true,
   toc = nil,--need test
  },
 },
 PALADIN = {
  [85247] = {
   --aura = 85247,--Holy Power
   trigger = {
    [1] = 88855,--Tower of Radiance Rank 3
   },
   enable = true,
   toc = nil,
  },
  [88688] = {
   --aura = 88688,--Surge of Light
   trigger = {
    [1] = 88687,--Surge of Light Rank 1
    [2] = 88690,--Surge of Light Rank 2
   },
   enable = true,
   toc = nil,
  },
  [85433] = {
   --aura = 85433,--Sacred Duty
   trigger = {
    [1] = 53709,--Sacred Duty Rank 1
    [2] = 53710,--Sacred Duty Rank 2
   },
   enable = true,
   toc = nil,
  },
  [90174] = {
   --aura = 90174,--Hand of Light
   trigger = {
    [1] = 90174,--Hand of Light
   },
   enable = true,
   toc = nil,
  },
  [85416] = {
   --aura = 85416,--Grand Crusader
   trigger = {
    [1] = 75806,--Grand Crusader Rank 1
    [2] = 85043,--Grand Crusader Rank 2
   },
   enable = true,
   toc = nil,
  },
  [85509] = {
   --aura = 85509,--Denounce
   trigger = {
    [1] = 31825,--Denounce Rank 1
    [2] = 85510,--Denounce Rank 2
   },
   enable = true,
   toc = nil,
  },
  [88819] = {
   --aura = 88819,--Daybreak
   trigger = {
    [1] = 88820,--Daybreak Rank 1
    [2] = 88821,--Daybreak Rank 2
   },
   enable = true,
   toc = nil,
  },
  [53489] = {
   --aura = 53489,--The Art of War
   trigger = {
    [1] = 53486,--The Art of War Rank 1
   },
   enable = true,
   toc = nil,
  },
  [59578] = {
   --aura = 59578,--The Art of War Rank 2
   trigger = {
    [1] = 53488,--The Art of War Rank 2
   },
   enable = true,
   toc = nil,
  },
  [53672] = {
   --aura = 53672,--Infusion of Light
   trigger = {
    [1] = 53569,--Infusion of Light Rank 1
   },
   enable = true,
   toc = nil,
  },
  [54149] = {
   --aura = 54149,--Infusion of Light Rank 2
   trigger = {
    [1] = 53576,--Infusion of Light Rank 2
   },
   enable = true,
   toc = nil,
  },
  [20128] = {
   --aura = 20128,--Redoubt
   trigger = {
    [1] = 20127,--Redoubt Rank 1
   },
   enable = true,
   toc = nil,
  },
  [20131] = {
   --aura = 20131,--Redoubt
   trigger = {
    [1] = 20130,--Redoubt Rank 2
   },
   enable = true,
   toc = nil,
  },
  [20132] = {
   --aura = 20132,--Redoubt
   trigger = {
    [1] = 20135,--Redoubt Rank 3
   },
   enable = true,
   toc = nil,
  },
  [20050] = {
   --aura = 20050,--Vengeance
   trigger = {
    [1] = 20049,--Vengeance Rank 1
   },
   enable = true,
   toc = nil,
  },
  [20052] = {
   --aura = 20052,--Vengeance
   trigger = {
    [1] = 20056,--Vengeance Rank 2
   },
   enable = true,
   toc = nil,
  },
  [20053] = {
   --aura = 20053,--Vengeance
   trigger = {
    [1] = 20057,--Vengeance Rank 3
   },
   enable = true,
   toc = nil,
  },
 },
 PRIEST = {
  [91141] = {
   --aura = 91141,--
   trigger = {
    [1] = 91141,--
   },
   enable = true,
   toc = nil,
  },
  [90953] = {
   --aura = 90953,--
   trigger = {
    [1] = 90953,--
   },
   enable = true,
   toc = nil,
  },
  [77487] = {
   --aura = 77487,--Shadow Orb
   trigger = {
    [1] = 33191,--Harnessed Shadows
    [2] = 78228,--Harnessed Shadows
   },
   enable = true,
   toc = nil,
  },
  [88688] = {
   --aura = 88688,--Surge of Light
   trigger = {
    [1] = 88687,--Surge of Light Rank 1
    [2] = 88690,--Surge of Light Rank 2
   },
   enable = true,
   toc = nil,
  },
  [87117] = {
   --aura = 87117,--Dark Evangelism
   trigger = {
    [1] = 87117,--Dark Evangelism
   },
   enable = true,
   toc = nil,
  },
  [87118] = {
   --aura = 87118,--Dark Evangelism
   trigger = {
    [1] = 87118,--Dark Evangelism
   },
   enable = true,
   toc = nil,
  },
  [81661] = {
   --aura = 81661,--Evangelism
   trigger = {
    [1] = 81661,--Evangelism
   },
   enable = true,
   toc = nil,
  },
  [81660] = {
   --aura = 81660,--Evangelism
   trigger = {
    [1] = 81660,--Evangelism
   },
   enable = true,
   toc = nil,
  },
  [33151] = {
   --aura = 33151,--Surge of Light
   trigger = {
    [1] = 33150,--Surge of Light Rank 1
    [2] = 33154,--Surge of Light Rank 2
   },
   enable = true,
   toc = nil,
  },
  [34754] = {
   --aura = 34754,--Holy Concentration
   trigger = {
    [1] = 34753,--Holy Concentration Rank 1
   },
   enable = true,
   toc = nil,
  },
  [63724] = {
   --aura = 63724,--Holy Concentration
   trigger = {
    [1] = 34859,--Holy Concentration Rank 2
   },
   enable = true,
   toc = nil,
  },
  [63725] = {
   --aura = 63725,--Holy Concentration
   trigger = {
    [1] = 34860,--Holy Concentration Rank 3
   },
   enable = true,
   toc = nil,
  },
  [63731] = {
   --aura = 63731,--Serendipity
   trigger = {
    [1] = 63730,--Serendipity Rank 1
   },
   enable = true,
   toc = nil,
  },
  [63735] = {
   --aura = 63735,--Serendipity
   trigger = {
    [1] = 63733,--Serendipity Rank 2
   },
   enable = true,
   toc = nil,
  },
  [63734] = {
   --aura = 63734,--Serendipity
   trigger = {
    [1] = 63737,--Serendipity Rank 3
   },
   enable = true,
   toc = nil,
  },
  [59887] = {
   --aura = 59887,--Borrowed Time
   trigger = {
    [1] = 52795,--Borrowed Time Rank 1
   },
   enable = true,
   toc = nil,
  },
  [59888] = {
   --aura = 59888,--Borrowed Time
   trigger = {
    [1] = 52797,--Borrowed Time Rank 2
   },
   enable = true,
   toc = nil,
  },
  [59889] = {
   --aura = 59889,--Borrowed Time
   trigger = {
    [1] = 52798,--Borrowed Time Rank 3
   },
   enable = true,
   toc = nil,
  },
  [59890] = {
   --aura = 59890,--Borrowed Time
   trigger = {
    [1] = 52799,--Borrowed Time Rank 4
   },
   enable = true,
   toc = nil,
  },
  [59891] = {
   --aura = 59891,--Borrowed Time
   trigger = {
    [1] = 52800,--Borrowed Time Rank 5
   },
   enable = true,
   toc = nil,
  },
  [14743] = {
   --aura = 14743,--Focused Casting
   trigger = {
    [1] = 14531,--Martyrdom Rank 1
   },
   enable = true,
   toc = nil,
  },
  [27828] = {
   --aura = 27828,--Focused Casting
   trigger = {
    [1] = 14774,--Martyrdom Rank 2
   },
   enable = true,
   toc = nil,
  },
 },
 ROGUE = {
  [14251] = {
   --aura = 14251,--Riposte
   trigger = {
    [1] = 14251,--Riposte
   },
   enable = true,
   toc = nil,
  },
  [67210] = {
   --aura = 67210,--Clearcasting
   trigger = {
    [1] = 67209,--Item - Rogue T9 2P Bonus (Rupture)
   },
   enable = true,
   toc = 30300,
  },
 },
 SHAMAN = {
  [324] = {
   --aura = 324,--Clearcasting
   trigger = {
    [1] = 324,--Elemental Focus
   },
   enable = true,
   toc = nil,
  },
  [16246] = {
   --aura = 16246,--Clearcasting
   trigger = {
    [1] = 16164,--Elemental Focus
   },
   enable = true,
   toc = nil,
  },
  [53817] = {
   --aura = 53817,--Maelstrom Weapon
   trigger = {
    [1] = 51528,--Maelstrom Weapon Rank 1
    [2] = 51529,--Maelstrom Weapon Rank 2
    [3] = 51530,--Maelstrom Weapon Rank 3
    [4] = 51531,--Maelstrom Weapon Rank 4
    [5] = 51532,--Maelstrom Weapon Rank 5
   },
   enable = true,
   toc = nil,
  },
  [53390] = {
   --aura = 53390,--Tidal Waves
   trigger = {
    [1] = 51562,--Tidal Waves Rank 1
    [2] = 51563,--Tidal Waves Rank 2
    [3] = 51564,--Tidal Waves Rank 3
    [4] = 51565,--Tidal Waves Rank 4
    [5] = 51566,--Tidal Waves Rank 5
   },
   enable = true,
   toc = nil,
  },
  [53410] = {
   --aura = 53410,--Elemental Oath
   trigger = {
    [1] = 51466,--Elemental Oath Rank 1
   },
   enable = true,
   toc = nil,
  },
  [53414] = {
   --aura = 53414,--Elemental Oath
   trigger = {
    [1] = 51470,--Elemental Oath Rank 2
   },
   enable = true,
   toc = nil,
  },
 },
 WARLOCK = {
  [17941] = {
   --aura = 17941,--Shadow Trance
   trigger = {
    [1] = 18094,--Nightfall Rank 1
    [2] = 18095,--Nightfall Rank 2
   },
   enable = true,
   toc = nil,
  },
  [34936] = {
   --aura = 34936,--Backlash
   trigger = {
    [1] = 34935,--Backlash Rank 1
    [2] = 34938,--Backlash Rank 2
    [3] = 34939,--Backlash Rank 3
   },
   enable = true,
   toc = nil,
  },
  [54274] = {
   --aura = 54274,--Backdraft
   trigger = {
    [1] = 47258,--Backdraft Rank 1
   },
   enable = true,
   toc = nil,
  },
  [54276] = {
   --aura = 54276,--Backdraft
   trigger = {
    [1] = 47259,--Backdraft Rank 2
   },
   enable = true,
   toc = nil,
  },
  [54277] = {
   --aura = 54277,--Backdraft
   trigger = {
    [1] = 47260,--Backdraft Rank 3
   },
   enable = true,
   toc = nil,
  },
  [63165] = {
   --aura = 63165,--Decimation
   trigger = {
    [1] = 63156,--Decimation Rank 1
   },
   enable = true,
   toc = nil,
  },
  [63167] = {
   --aura = 63167,--Decimation
   trigger = {
    [1] = 63158,--Decimation Rank 2
   },
   enable = true,
   toc = nil,
  },
  [47283] = {
   --aura = 47283,--Empowered Imp
   trigger = {
    [1] = 47220,--Empowered Imp Rank 1
    [2] = 47221,--Empowered Imp Rank 2
    [3] = 47223,--Empowered Imp Rank 3
   },
   enable = true,
   toc = nil,
  },
  [47383] = {
   --aura = 47383,--Molten Core
   trigger = {
    [1] = 47245,--Molten Core Rank 1
   },
   enable = true,
   toc = nil,
  },
  [71162] = {
   --aura = 71162,--Molten Core
   trigger = {
    [1] = 47246,--Molten Core Rank 2
   },
   enable = true,
   toc = nil,
  },
  [71165] = {
   --aura = 71165,--Molten Core
   trigger = {
    [1] = 47247,--Molten Core Rank 3
   },
   enable = true,
   toc = nil,
  },
  [63321] = {
   --aura = 63321,--Life Tap
   trigger = {
    [1] = 63321,--Life Tap
   },
   enable = true,
   toc = nil,
  },
  [18093] = {
   --aura = 18093,--Pyroclasm
   trigger = {
    [1] = 18096,--Pyroclasm Rank 1
   },
   enable = true,
   toc = nil,
  },
  [63243] = {
   --aura = 63243,--Pyroclasm
   trigger = {
    [1] = 18073,--Pyroclasm Rank 2
   },
   enable = true,
   toc = nil,
  },
  [63244] = {
   --aura = 63244,--Pyroclasm
   trigger = {
    [1] = 63245,--Pyroclasm Rank 3
   },
   enable = true,
   toc = nil,
  },
  [64368] = {
   --aura = 64368,--Eradication
   trigger = {
    [1] = 47195,--Eradication Rank 1
   },
   enable = true,
   toc = nil,
  },
  [64370] = {
   --aura = 64370,--Eradication
   trigger = {
    [1] = 47196,--Eradication Rank 2
   },
   enable = true,
   toc = nil,
  },
  [64371] = {
   --aura = 64371,--Eradication
   trigger = {
    [1] = 47197,--Eradication Rank 3
   },
   enable = true,
   toc = nil,
  },
  [61595] = {
   --aura = 61595,--Demonic Soul
   trigger = {
    [1] = 60170,--Corruption Triggers Crit
   },
   enable = false,
   toc = nil,
  },
 },
 WARRIOR = {
  [87095] = {
   --aura = 87095,--Thunderstruck
   trigger = {
    [1] = 80979,--Thunderstruck Rank 1
   },
   enable = true,
   toc = nil,
  },
  [87096] = {
   --aura = 87096,--Thunderstruck
   trigger = {
    [1] = 80980,--Thunderstruck Rank 2
   },
   enable = true,
   toc = nil,
  },
  [84584] = {
   --aura = 84584,--Slaughter
   trigger = {
    [1] = 84583,--Lambs to the Slaughter Rank 1
   },
   enable = true,
   toc = nil,
  },
  [84585] = {
   --aura = 84585,--Slaughter
   trigger = {
    [1] = 84587,--Lambs to the Slaughter Rank 2
   },
   enable = true,
   toc = nil,
  },
  [84586] = {
   --aura = 84586,--Slaughter
   trigger = {
    [1] = 84588,--Lambs to the Slaughter Rank 3
   },
   enable = true,
   toc = nil,
  },

  [86627] = {
   --aura = 86627,--Incite
   trigger = {
    [1] = 50685,--Incite Rank 1
    [2] = 50686,--Incite Rank 2
    [3] = 50687,--Incite Rank 3
   },
   enable = true,
   toc = nil,
  },
  [12964] = {
   --aura = 12964,--Battle Trance
   trigger = {
    [1] = 12322,--Battle Trance Rank 1
    [2] = 85741,--Battle Trance Rank 2
    [3] = 85742,--Battle Trance Rank 3
   },
   enable = true,
   toc = nil,
  },
  [46916] = {
   --aura = 46916,--Bloodsurge
   trigger = {
    [1] = 46913,--Bloodsurge Rank 1
    [2] = 46914,--Bloodsurge Rank 2
    [3] = 46915,--Bloodsurge Rank 3
   },
   enable = true,
   toc = nil,
  },
  [60503] = {
   --aura = 60503,--Taste for Blood
   trigger = {
    [1] = 56636,--Taste for Blood Rank 1
    [2] = 56637,--Taste for Blood Rank 2
    [3] = 56638,--Taste for Blood Rank 3
   },
   enable = true,
   toc = nil,
  },
  [52437] = {
   --aura = 52437,--Sudden Death
   trigger = {
    [1] = 29723,--Sudden Death Rank 1
    [2] = 29725,--Sudden Death Rank 2
    [3] = 29724,--Sudden Death Rank 3
   },
   enable = true,
   toc = nil,
  },
  [50227] = {
   --aura = 50227,--Sword and Board
   trigger = {
    [1] = 46951,--Sword and Board Rank 1
    [2] = 46952,--Sword and Board Rank 2
    [3] = 46953,--Sword and Board Rank 3
   },
   enable = true,
   toc = nil,
  },
  [58363] = {
   --aura = 58363,--Glyph of Revenge
   item = 43424,--Glyph of Revenge
   trigger = {
    [1] = 58364,--Glyph of Revenge
   },
   enable = true,
   toc = nil,
  },
  [61571] = {
   --aura = 61571,--Spirits of the Lost
   trigger = {
    [1] = 60176,--Bleed Cost Reduction
   },
   enable = false,
   toc = nil,
  },
 },
}

CommonAuraData = {
 COMMON = {
  --enchants:BC

  [28093] = {
   --aura = 28093,--Lightning Speed
   item = 22559,--Formula: Enchant Weapon - Mongoose
   trigger = {
    [1] = 27984,--Enchant Weapon - Mongoose
   },
   enable = false,
   toc = 30100,
  },
  [20007] = {
   --aura = 20007,--Holy Strength
   item = 16252,--Formula: Enchant Weapon - Crusader
   trigger = {
    [1] = 20034,--Enchant Weapon - Crusader
   },
   enable = false,
   toc = 30100,
  },
  [42976] = {
   --aura = 42976,--Executioner
   item = 33307,--Formula: Enchant Weapon - Executioner
   trigger = {
    [1] = 42974,--Enchant Weapon - Executioner
   },
   enable = false,
   toc = 30100,
  },

  --enchants:WLK

  [59620] = {
   --aura = 59620,--Berserk
   item = 44492,--Formula: Enchant Weapon - Berserking
   trigger = {
    [1] = 59621,--Enchant Weapon - Berserking
   },
   enable = false,
   toc = 30300,
  },
  [59626] = {
   --aura = 59626,--Black Magic
   item = 44495,--Formula: Enchant Weapon - Black Magic
   trigger = {
    [1] = 59630,--Black Magic
    --[2] = 59625--Enchant Weapon - Black Magic
   },
   enable = false,
   toc = 30300,
  },
  [44578] = {
   --aura = 44578,--Lifeward
   item = 44494,--Formula: Enchant Weapon - Lifeward
   trigger = {
    [1] = 44578,--trigger missing
   },
   enable = false,
   toc = 30300,
  },
  [55637] = {
   --aura = 55637,--Lightweave
   item = nil,--
   trigger = {
    [1] = 55640,--Lightweave Embroidery
    --[2] = 55642,--Lightweave Embroidery
   },
   enable = false,
   toc = 30300,
  },
  [55767] = {
   --aura = 55767,--Darkglow
   item = nil,--
   trigger = {
    [1] = 55768,--Darkglow Embroidery
    --[2] = 55769,--Darkglow Embroidery
   },
   enable = false,
   toc = 30300,
  },
  [55775] = {
   --aura = 55775,--Swordguard Embroidery
   item = nil,--
   trigger = {
    [1] = 55776,--Swordguard Embroidery
    --[2] = 55777,--Swordguard Embroidery
   },
   enable = false,
   toc = 30300,
  },
  [64440] = {
   --aura = 64440,--Blade Warding
   item = nil,--
   trigger = {
    [1] = 64440,--trigger missing
   },
   enable = false,
   toc = nil,
  },
  [64568] = {
   --aura = 64568,--Blood Reserve
   item = 46348,--Formula: Enchant Weapon - Blood Draining
   trigger = {
    [1] = 64571,--Blood Draining
    --[2] = 64579,--Enchant Weapon - Blood Draining
   },
   enable = false,
   toc = 30300,
  },

  --items:BC

  [35081] = {
   --aura = 35081,--Band of the Eternal Champion
   item = 29301,--Band of the Eternal Champion
   trigger = {
    [1] = 35080,--Band of the Eternal Champion
   },
   enable = false,
   toc = 30100,
  },
  [35087] = {
   --aura = 35087,--Band of the Eternal Restorer
   item = 29309,--Band of the Eternal Restorer
   trigger = {
    [1] = 35086,--Band of the Eternal Restorer
   },
   enable = false,
   toc = 30100,
  },
  [35078] = {
   --aura = 35078,--Band of the Eternal Defender
   item = 29297,--Band of the Eternal Defender
   trigger = {
    [1] = 35077,--Band of the Eternal Defender
   },
   enable = false,
   toc = 30100,
  },
  [35084] = {
   --aura = 35084,--Band of the Eternal Sage
   item = 29305,--Band of the Eternal Sage
   trigger = {
    [1] = 35083,--Band of the Eternal Sage
   },
   enable = false,
   toc = 30100,
  },
  [34747] = {
   --aura = 34747,--Recurring Power
   item = 28789,--Eye of Magtheridon
   trigger = {
    [1] = 34749,--Recurring Power
   },
   enable = false,
   toc = 30100,
  },
  [33649] = {
   --aura = 33649,--Rage of the Unraveller
   item = 28034,--Hourglass of the Unraveller
   trigger = {
    [1] = 60066,--Rage of the Unraveller
   },
   enable = false,
   toc = 30100,
  },
  [34775] = {
   --aura = 34775,--Dragonspine Flurry
   item = 28830,--Dragonspine Trophy
   trigger = {
    [1] = 34774,--Magtheridon Melee Trinket
   },
   enable = false,
   toc = 30100,
  },
  [42084] = {
   --aura = 42084,--Fury of the Crashing Waves
   item = 30627,--Tsunami Talisman
   trigger = {
    [1] = 42083,--Fury of the Crashing Waves
   },
   enable = false,
   toc = 30100,
  },
  [37174] = {
   --aura = 37174,--Perceived Weakness
   item = 30450,--Warp-Spring Coil
   trigger = {
    [1] = 37173,--Armor Penetration
   },
   enable = false,
   toc = 30100,
  },
  [38348] = {
   --aura = 38348,--Unstable Currents
   item = 30626,--Sextant of Unstable Currents
   trigger = {
    [1] = 38347,--Crit aura Spell Damage
   },
   enable = false,
   toc = 30100,
  },
  [45053] = {
   --aura = 45053,--Disdain
   item = 34472,--Shard of Contempt
   trigger = {
    [1] = 45354,--Item - Sunwell Dungeon Melee Trinket
   },
   enable = false,
   toc = 30100,
  },
  [40487] = {
   --aura = 40487,--Deadly Aim
   item = 32487,--Ashtongue Talisman of Swiftness
   trigger = {
    [1] = 40485,--Hunter Tier 6 Trinket
   },
   enable = false,
   toc = 30100,
  },
  [40483] = {
   --aura = 40483,--Insight of the Ashtongue
   item = 32488,--Ashtongue Talisman of Insight
   trigger = {
    [1] = 40482,--Mage Tier 6 Trinket
   },
   enable = false,
   toc = 30100,
  },
  [40480] = {
   --aura = 40480,--Power of the Ashtongue
   item = 32493,--Ashtongue Talisman of Shadows
   trigger = {
    [1] = 40478,--Warlock Tier 6 Trinket
   },
   enable = false,
   toc = 30100,
  },
  [33370] = {
   --aura = 33370,--Spell Haste
   item = 27683,--Quagmirran's Eye
   --item = 28190,--Scarab of the Infinite Cycle
   trigger = {
    [1] = 60061,--Flow of Time
    [2] = 33297,--Spell Haste Trinket
   },
   enable = false,
   toc = 30100,
  },
  [45058] = {
   --aura = 45058,--Evasive Maneuvers
   item = 34473,--Commendation of Kael'thas
   trigger = {
    [1] = 45057,--Evasive Maneuvers
   },
   enable = false,
   toc = 30100,
  },
  [40408] = {
   --aura = 40408,--Unbreakable
   item = 32375,--Bulwark of Azzinoth
   trigger = {
    [1] = 40407,--Illidan Tank Shield
   },
   enable = false,
   toc = 30100,
  },
  [43749] = {
   --aura = 43749,--Elemental Strength
   item = 33507,--Stonebreaker's Totem
   trigger = {
    [1] = 43748,--Elemental Strength
   },
   enable = false,
   toc = 30100,
  },
  [43747] = {
   --aura = 43747,--Crusader's Command
   item = 33503,--Libram of Divine Judgement
   trigger = {
    [1] = 43745,--Crusader's Command
    [2] = 60576,--Copy of Crusader's Command
   },
   enable = false,
   toc = 30100,
  },
  [40477] = {
   --aura = 40477,--Forceful Strike
   item = 32505,--Madness of the Betrayer
   trigger = {
    [1] = 40475,--Black Temple Melee Trinket
   },
   enable = false,
   toc = 30100,
  },
  [45480] = {
   --aura = 45480,--Light's Strength
   item = 34679,--Shattered Sun Pendant of Might
   trigger = {
    [1] = 45480,--trigger missing
   },
   enable = false,
   toc = 30100,
  },
  [34585] = {
   --aura = 34585,--Love Struck
   item = 28578,--Masquerade Gown
   trigger = {
    [1] = 34584,--Love Struck
   },
   enable = false,
   toc = 30100,
  },
  [43738] = {
   --aura = 43738,--Primal Instinct
   item = 33509,--Idol of Terror
   trigger = {
    [1] = 43737,--Primal Instinct
   },
   enable = false,
   toc = 30100,
  },

  --items:WLK

  [64411] = {
   --aura = 64411,--Blessing of Ancient Kings
   item = 46017,--Val'anyr, Hammer of Ancient Kings
   trigger = {
    [1] = 64415,--Val'anyr Hammer of Ancient Kings - Equip Effect
   },
   enable = false,
   toc = 30300,
  },
  [64413] = {
   --aura = 64413,--Protection of Ancient Kings
   item = 46017,--Val'anyr, Hammer of Ancient Kings
   trigger = {
    [1] = 64413,--Protection of Ancient Kings
   },
   enable = false,
   toc = 30300,
  },
  [60065] = {
   --aura = 60065,--Reflection of Torment
   item = 40684,--Mirror of Truth
   --item = 49074,--Coren's Chromium Coaster
   --item = 44914,--Anvil of Titans
   trigger = {
    [1] = 33648,--Reflection of Torment
    [2] = 62115,--Strength of the Titans
   },
   enable = false,
   toc = 30300,
  },
  [60437] = {
   --aura = 60437,--Grim Toll
   item = 40256,--Grim Toll
   trigger = {
    [1] = 60436,--Grim Toll
   },
   enable = false,
   toc = 30300,
  },
  [60530] = {
   --aura = 60530,--Forethought Talisman
   item = 40258,--Forethought Talisman
   trigger = {
    [1] = 60529,--Forethought Talisman
   },
   enable = false,
   toc = 30300,
  },
  [60314] = {
   --aura = 60314,--Fury of the Five Flights
   item = 40431,--Fury of the Five Flights
   trigger = {
    [1] = 60313,--Fury of the Five Flights
   },
   enable = false,
   toc = 30300,
  },
  [60486] = {
   --aura = 60486,--Illustration of the Dragon Soul
   item = 40432,--Illustration of the Dragon Soul
   trigger = {
    [1] = 60485,--Illustration of the Dragon Soul
   },
   enable = false,
   toc = 30300,
  },
  [60538] = {
   --aura = 60538,--Soul of the Dead
   item = 40382,--Soul of the Dead
   trigger = {
    [1] = 60537,--Soul of the Dead
   },
   enable = false,
   toc = 30300,
  },
  [60196] = {
   --aura = 60196,--Berserker!
   item = 42989,--Darkmoon Card: Berserker!
   trigger = {
    [1] = 57351,--Berserker!
   },
   enable = false,
   toc = 30300,
  },
  [60492] = {
   --aura = 60492,--Embrace of the Spider
   item = 39229,--Embrace of the Spider
   trigger = {
    [1] = 60490,--Embrace of the Spider
   },
   enable = false,
   toc = 30300,
  },
  [49623] = {
   --aura = 49623,--Effervescence
   item = 49622,--Je'Tze's Bell
   trigger = {
    [1] = 49622,--Bonus Mana Regen
   },
   enable = false,
   toc = 30300,
  },
  [60064] = {
   --aura = 60064,--Now is the time!
   item = 40682,--Sundial of the Exiled
   --item = 49076,--Mithril Pocketwatch
   --item = 44912,--Flow of Knowledge
   trigger = {
    [1] = 62114,--Flow of Knowledge
    [2] = 60063,--Now is the Time!
   },
   enable = false,
   toc = 30300,
  },
  [58904] = {
   --aura = 58904,--Tears of Anguish
   item = 43573,--Tears of Bitter Anguish
   trigger = {
    [1] = 58901,--Tears of Anguish
   },
   enable = false,
   toc = 30300,
  },
  [60062] = {
   --aura = 60062,--Essence of Life
   item = 40685,--The Egg of Mortal Essence
   --item = 49078,--Ancient Pickled Egg
   trigger = {
    [1] = 33953,--Essence of Life
   },
   enable = false,
   toc = 30300,
  },
  [60218] = {
   --aura = 60218,--Essence of Gossamer
   item = 37220,--Essence of Gossamer
   trigger = {
    [1] = 60221,--Essence of Gossamer
   },
   enable = false,
   toc = 30300,
  },
  [60302] = {
   --aura = 60302,--Meteorite Whetstone
   item = 37390,--Meteorite Whetstone
   trigger = {
    [1] = 60301,--Meteorite Whetstone
   },
   enable = false,
   toc = 30300,
  },
  [60520] = {
   --aura = 60520,--Spark of Life
   item = 37657,--Spark of Life
   trigger = {
    [1] = 60519,--Spark of Life
   },
   enable = false,
   toc = 30300,
  },
  [54697] = {
   --aura = 54697,--Oozing Wound
   item = 38212,--Death Knight's Anguish
   trigger = {
    [1] = 54696,--Wracking Pains
   },
   enable = false,
   toc = 30300,
  },
  [54696] = {
   --aura = 54696,--Wracking Pains
   item = 38212,--Death Knight's Anguish
   trigger = {
    [1] = 54695,--Item - Death Knight's Anguish Base
   },
   enable = false,
   toc = 30300,
  },
  [60525] = {
   --aura = 60525,--Majestic Dragon Figurine
   item = 40430,--Majestic Dragon Figurine
   trigger = {
    [1] = 60524,--Majestic Dragon Figurine
   },
   enable = false,
   toc = 30300,
  },
  [60233] = {
   --aura = 60233,--Greatness
   item = 44253,--Darkmoon Card: Greatness
   trigger = {
    [1] = 57345,--Darkmoon Card: Greatness
   },
   enable = false,
   toc = 30300,
  },
  [60235] = {
   --aura = 60235,--Greatness
   item = 44254,--Darkmoon Card: Greatness
   trigger = {
    [1] = 57345,--Darkmoon Card: Greatness
   },
   enable = false,
   toc = 30300,
  },
  [60234] = {
   --aura = 60234,--Greatness
   item = 44255,--Darkmoon Card: Greatness
   trigger = {
    [1] = 57345,--Darkmoon Card: Greatness
   },
   enable = false,
   toc = 30300,
  },
  [60229] = {
   --aura = 60229,--Greatness
   item = 42987,--Darkmoon Card: Greatness
   trigger = {
    [1] = 57345,--Darkmoon Card: Greatness
   },
   enable = false,
   toc = 30300,
  },
  [60513] = {
   --aura = 60513,--Healing Trance
   item = 37111,--Soul Preserver
   trigger = {
    [1] = 60510,--Soul Preserver
   },
   enable = false,
   toc = 30300,
  },
  [65004] = {
   --aura = 65004,--Alacrity of the Elements
   item = 45866,--Elemental Focus Stone
   trigger = {
    [1] = 65005,--Alacrity of the Elements
   },
   enable = false,
   toc = 30300,
  },
  [65006] = {
   --aura = 65006,--Eye of the Broodmother
   item = 45308,--Eye of the Broodmother
   trigger = {
    [1] = 65007,--Eye of the Broodmother
   },
   enable = false,
   toc = 30300,
  },
  [65019] = {
   --aura = 65019,--Mjolnir Runestone
   item = 45931,--Mjolnir Runestone
   trigger = {
    [1] = 65020,--Mjolnir Runestone
   },
   enable = false,
   toc = 30300,
  },
  [65014] = {
   --aura = 65014,--Pyrite Infusion
   item = 45286,--Pyrite Infuser
   trigger = {
    [1] = 65013,--Pyrite Infusion
   },
   enable = false,
   toc = 30300,
  },
  [65003] = {
   --aura = 65003,--Memories of Love
   item = 65002,--Sif's Remembrance
   trigger = {
    [1] = 65002,--Bonus Mana Regen
   },
   enable = false,
   toc = 30300,
  },
  [64951] = {
   --aura = 64951,--Primal Wrath
   item = 45509,--Idol of the Corruptor
   trigger = {
    [1] = 64952,--Item - Druid T8 Feral Relic
   },
   enable = false,
   toc = 30300,
  },
  [64741] = {
   --aura = 64741,--Pandora's Plea
   item = 45490,--Pandora's Plea
   trigger = {
    [1] = 64742,--Pandora's Plea
   },
   enable = false,
   toc = 30300,
  },
  [64765] = {
   --aura = 64765,--The General's Heart
   item = 45507,--The General's Heart
   trigger = {
    [1] = 64764,--The General's Heart
   },
   enable = false,
   toc = 30300,
  },
 },
}

ClassSpellData = {
 DEATHKNIGHT = {
  [63560] = {
   --spell = 63560,--Dark Transformation
   enable = true,
   toc = nil,
  },
  [56815] = {
   --spell = 56815,--Rune Strike
   enable = true,
   toc = nil,
  },
 },
 DRUID = {
 },
 HUNTER = {
  [19306] = {
   --spell = 19306,--Counterattack
   enable = true,
   toc = nil,
  },
  [53351] = {
   --spell = 53351,--Kill Shot
   enable = true,
   toc = nil,
  },
  [61005] = {
   --spell = 61005,--Kill Shot
   enable = true,
   toc = nil,
  },
  [61006] = {
   --spell = 61006,--Kill Shot
   enable = true,
   toc = nil,
  },
 },
 MAGE = {
 },
 PALADIN = {
  [24275] = {
   --spell = 24275,--Hammer of Wrath
   enable = true,
   toc = nil,
  },
  [24274] = {
   --spell = 24274,--Hammer of Wrath
   enable = true,
   toc = nil,
  },
  [24239] = {
   --spell = 24239,--Hammer of Wrath
   enable = true,
   toc = nil,
  },
  [27180] = {
   --spell = 27180,--Hammer of Wrath
   enable = true,
   toc = nil,
  },
  [48805] = {
   --spell = 48805,--Hammer of Wrath
   enable = true,
   toc = nil,
  },
  [48806] = {
   --spell = 48806,--Hammer of Wrath
   enable = true,
   toc = nil,
  },
 },
 PRIEST = {
 },
 ROGUE = {
  [14251] = {
   --spell = 14251,--Riposte
   enable = true,
   toc = nil,
  },
 },
 SHAMAN = {
  [77762] = {
   --aura = 77762,--Lava Surge!
   enable = true,
   toc = nil,
  },
 },
 WARLOCK = {
  [17877] = {
   --spell = 17877,--Shadowburn
   enable = true,
   toc = nil,
  },
 },
 WARRIOR = {
  [85288] = {
   --spell = 85288,--Raging Blow
   enable = false,
   toc = nil,
  },
  [7384] = {
   --spell = 7384,--Overpower
   enable = true,
   toc = nil,
  },
  [5308] = {
   --spell = 5308,--Execute
   enable = true,
   toc = nil,
  },
  [20658] = {
   --spell = 20658,--Execute
   enable = true,
   toc = nil,
  },
  [20660] = {
   --spell = 20660,--Execute
   enable = true,
   toc = nil,
  },
  [20661] = {
   --spell = 20661,--Execute
   enable = true,
   toc = nil,
  },
  [20662] = {
   --spell = 20662,--Execute
   enable = true,
   toc = nil,
  },
  [25234] = {
   --spell = 25234,--Execute
   enable = true,
   toc = nil,
  },
  [25236] = {
   --spell = 25236,--Execute
   enable = true,
   toc = nil,
  },
  [47470] = {
   --spell = 47470,--Execute
   enable = true,
   toc = nil,
  },
  [47471] = {
   --spell = 47471,--Execute
   enable = true,
   toc = nil,
  },
  [6572] = {
   --spell = 6572,--Revenge
   enable = true,
   toc = nil,
  },
  [6574] = {
   --spell = 6574,--Revenge
   enable = true,
   toc = nil,
  },
  [7379] = {
   --spell = 7379,--Revenge
   enable = true,
   toc = nil,
  },
  [11600] = {
   --spell = 11600,--Revenge
   enable = true,
   toc = nil,
  },
  [11601] = {
   --spell = 11601,--Revenge
   enable = true,
   toc = nil,
  },
  [25288] = {
   --spell = 25288,--Revenge
   enable = true,
   toc = nil,
  },
  [25269] = {
   --spell = 25269,--Revenge
   enable = true,
   toc = nil,
  },
  [30357] = {
   --spell = 30357,--Revenge
   enable = true,
   toc = nil,
  },
  [57823] = {
   --spell = 57823,--Revenge
   enable = true,
   toc = nil,
  },
  [34428] = {
   --spell = 34428,--Victory Rush
   enable = true,
   toc = nil,
  },
 },
}
end
function STD:InitData()
 ST.data = {}
 ST.data.aura = {}
 ST.data.spell = {}
 ST.desc = {}
 ST.desc.aura = {}
 ST.desc.spell = {}
 ST.active_item = {}
 ST.queue = {}
end
function STD:LoadAuraClassData(TocFilterActive)
 ST.data.aura.class = {}
 ST.desc.aura.class = {}
 for SpellId,SpellTable in pairs(ClassAuraData[classFileName]) do
  if not STD:TocFilter(TocFilterActive, SpellTable.toc) and not STD:SpellIdFilter(SpellIdFilterActive, SpellId) and not STD:SpellIdFilter(SpellIdFilterActive, SpellTable.trigger[table.maxn(SpellTable.trigger)]) then
   local triggerSpellName, triggerSpellRank, triggerSpellIcon, _, _, _, _, _, _ = GetSpellInfo(SpellTable.trigger[table.maxn(SpellTable.trigger)])
   triggerSpellIcon = "|T".. triggerSpellIcon .. ":0|t"
   if (not triggerSpellRank) or (table.getn(SpellTable.trigger) > 1) or triggerSpellRank == "" then triggerSpellRank = "" else triggerSpellRank = "(" .. triggerSpellRank .. ")" end
   ST.data.aura.class[SpellId] = SpellTable.enable
   ST.desc.aura.class[SpellId] = triggerSpellIcon .. triggerSpellName .. triggerSpellRank
  end
 end
end
function STD:LoadAuraCommonData(TocFilterActive)
 ST.data.aura.common = {}
 ST.desc.aura.common = {}
 for SpellId,SpellTable in pairs(CommonAuraData["COMMON"]) do
  if  not STD:TocFilter(TocFilterActive, SpellTable.toc) and not STD:SpellIdFilter(SpellIdFilterActive, SpellId) then
    local auraName = select(1, GetSpellInfo(SpellId)) or "N/A"
    local auraIcon = select(3, GetSpellInfo(SpellId)) or ""
    local triggerItemLink, triggerItemIcon
    if SpellTable.item then
     _, triggerItemLink, _, _, _, _, _, _, _, triggerItemIcon, _ = GetItemInfo(SpellTable.item)
    end
    if not triggerItemLink then triggerItemLink = auraName end
    if not triggerItemIcon then triggerItemIcon = auraIcon end
    auraIcon = "|T".. auraIcon .. ":0|t"
    triggerItemIcon = "|T".. triggerItemIcon .. ":0|t"
    ST.data.aura.common[SpellId] = SpellTable.enable
    ST.desc.aura.common[SpellId] = triggerItemIcon .. triggerItemLink .. " - " .. auraIcon .. auraName
  end
 end
end
function STD:LoadSpellClassData(TocFilterActive)
 ST.data.spell.class = {}
 ST.desc.spell.class = {}
 for SpellId,SpellTable in pairs(ClassSpellData[classFileName]) do
  if  not STD:TocFilter(TocFilterActive, SpellTable.toc) and not STD:SpellIdFilter(SpellIdFilterActive, SpellId) then
   local spellName, spellRank, spellIcon, _, _, _, _, _, _ = GetSpellInfo(SpellId)
   spellIcon = "|T".. spellIcon .. ":0|t"
   if (not spellRank) or spellRank == "" then spellRank = "" else spellRank = "(" .. spellRank .. ")" end
   ST.data.spell.class[SpellId] = SpellTable.enable
   ST.desc.spell.class[SpellId] = spellIcon .. spellName .. spellRank
  end
 end
end
function STD:TocFilter(FilterActive, toc)
 return FilterActive and toc and toc ~= uiVersion
end
function STD:SpellIdFilter(FilterActive, SpellId)
 return FilterActive and (not GetSpellInfo(SpellId))
end
